Index: trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 784)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 889)
@@ -23,5 +23,4 @@
 !  nstock     frequency of restart file
 !  nwrite     frequency of OUTPUT file
-!  nrunoff    = 0 no, 1 runoff, 2 runoff+river mouth ups adv
 !  ln_dimgnnn (F/T) 1 DIMG file - (for all proc/per proc)
 !
@@ -41,5 +40,4 @@
    nstock     =   10950
    nwrite     =   10950
-   nrunoff    =       0
    ln_dimgnnn = .FALSE.
 /
@@ -71,5 +69,5 @@
    nbit_cmp =     0
 /
-!!-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
 !       nam_mpp      Massively Parallel Processing
 !-----------------------------------------------------------------------
@@ -242,30 +240,4 @@
 /
 !-----------------------------------------------------------------------
-!       namtau   surface wind stress
-!-----------------------------------------------------------------------
-!  ntau000   gently increase the stress over the first ntau_rst time-steps
-!  tau0x     uniform value used as default surface heat flux
-!  tau0y     uniform value used as default solar radiation flux
-&namtau
-   ntau000 =      0
-   tau0x   =      0.e0
-   tau0y   =      0.e0
-/
-!-----------------------------------------------------------------------
-!       namflx   surface fluxes
-!-----------------------------------------------------------------------
-!  q0       uniform value used as default surface heat flux
-!  qsr0     uniform value used as default solar radiation flux
-!  emp0     uniform value used as default surface freswater budget (E-P)
-!  dqdt0    feedback coefficient for SST damping (W/m2/K)
-!  deds0    feedback coefficient for SSS damping (mm/day)
-&namflx
-   q0      =      0.e0
-   qsr0    =      0.e0
-   emp0    =      0.e0
-   dqdt0   =      -40.
-   deds0   =        0.
-/
-!-----------------------------------------------------------------------
 !       namalb   albedo parameters
 !-----------------------------------------------------------------------
@@ -302,8 +274,6 @@
 !  rdth       depth variation of tracer time step
 !  rdtbt      barotropic time step (for the time splitting algorithm)
-!  nfice      frequency of ice model call
-!  nfbulk     frequency of bulk formulea call (not used if ice used)
-!  nclosea    = 0 no closed sea 
-!             = 1 closed sea (Black Sea, Caspian Sea, Great US Lakes...) 
+!  nclosea    0 no closed sea 
+!             1 closed sea (Black Sea, Caspian Sea, Great US Lakes...) 
 &namdom
    ntopo     =     1
@@ -318,6 +288,4 @@
    rdth      =   800.
    rdtbt     =    90.
-   nfice     =     5  
-   nfbulk    =     5  
    nclosea   =     0
 /
@@ -642,43 +610,4 @@
 /
 !-----------------------------------------------------------------------
-!       namcpl    coupled ocean/atmosphere model  (#ifdef "key_coupled")
-!-----------------------------------------------------------------------
-!  nexco   coupling frequency in time steps
-!  cchan   coupling technique 'PIPE' or 'CLIM'
-&namcpl
-   nexco            =         24
-   cchan            =     'PIPE'
-   nmodcpl          =          2
-   cplmodnam        =   'opa.xx'
-   cploasis         =    'Oasis'
-   nfldo2c          =          2
-   nflxc2o          =          6
-   ntauc2o          =          4
-   cpl_writ(1)      = 'SOSSTSST'
-   cpl_f_writ(1)    =   'ocesst'
-   cpl_writ(2)      = 'SOICECOV'
-   cpl_f_writ(2)    =   'oceice'
-   cpl_readflx(1)   = 'SONSFLDO'
-   cpl_f_readflx(1) =   'oceflx'
-   cpl_readflx(2)   = 'SOSHFLDO'
-   cpl_f_readflx(2) =   'oceflx'
-   cpl_readflx(3)   = 'SOTOPRSU'
-   cpl_f_readflx(3) =   'oceflx'
-   cpl_readflx(4)   = 'SOTFSHSU'
-   cpl_f_readflx(4) =   'oceflx'
-   cpl_readflx(5)   = 'SORUNCOA'
-   cpl_f_readflx(5) =   'oceflx'
-   cpl_readflx(6)   = 'SORIVFLU'
-   cpl_f_readflx(6) =   'oceflx'
-   cpl_readtau(1)   = 'SOZOTAUX'
-   cpl_f_readtau(1) =   'ocetau'
-   cpl_readtau(2)   = 'SOZOTAU2'
-   cpl_f_readtau(2) =   'ocetau'
-   cpl_readtau(3)   = 'SOMETAUY'
-   cpl_f_readtau(3) =   'ocetau'
-   cpl_readtau(4)   = 'SOMETAU2'
-   cpl_f_readtau(4) =   'ocetau'
-/
-!-----------------------------------------------------------------------
 !       namobc    open boundaries parameters (#ifdef key_obc)
 !-----------------------------------------------------------------------
@@ -726,34 +655,172 @@
     ln_flork4 = .false.
 /
-!-----------------------------------------------------------------------
-!       namcore  CORE
-!-----------------------------------------------------------------------
-!
-!  In this version there are 8 files ( jpfile = 8)
+!!======================================================================
+!!              Surface Boundary Condition namelists
+!!
+!!       namsbc    surface boundary condition
+!!       namsbc_ana    analytical         formulation of sbc
+!!       namsbc_flx    flux               formulation of sbc
+!!       namsbc_core   CORE bulk formulea formulation of sbc
+!!       namsbc_clio   CLIO bulk formulea formulation of sbc
+!!       namsbc_cpl    CouPLed            formulation of sbc
+!!       namsbc_ssr    sea surface restoring term (for T and/or S)
+!!======================================================================
+!-----------------------------------------------------------------------
+!       namsbc       Surface Boundary Condition (surface module)
+!-----------------------------------------------------------------------
+!  nn_fsbc          frequency of surface boundary condition computation 
+!                   (also correspond to the frequency of sea-ice model call)
+!
+!  ln_ana        analytical formulation (fill namsbc_ana ) 
+!  ln_flx        flux formulation       (fill namsbc_flx ) (overwritten by key_sbc_flux     )
+!  ln_blk_clio   CLIO bulk formulation  (fill namsbc_core) (overwritten by key_sbc_bulk_clio)
+!  ln_blk_core   CORE bulk formulation  (fill namsbc_clio) (overwritten by key_sbc_bulk_core)
+!  ln_cpl        Coupled formulation    (fill namsbc_cpl ) (overwritten by key_sbc_coupled  )
+!
+!  nn_ice        =0 no ice boundary condition   ,
+!                =1 observed ice-cover          ,
+!                =2 ice-model ice-cover (overwritten by key_ice_lim)
+!
+!  ln_dm2dc     Daily mean to Diurnal Cycle short wave (qsr)
+!
+!  ln_ssr       Sea Surface restoring on SST and/or SSS (fill namsbc_ssr)
+!               (overwritten by key_dta_sst and/or key_dtasss)
+!
+!  nn_fwb       FreshWater Budget: =0 no control                              , 
+!                                  =1 annual global mean of emp set to zero   ,
+!                                  =2 global mean of emp set to zero at each nn_fsbc time step
+&namsbc
+   nn_fsbc     = 5
+   ln_ana      = .false.
+   ln_flx      = .false.
+   ln_blk_clio = .false.
+   ln_blk_core = .true.
+   ln_cpl      = .false.
+   nn_ice      = 2
+   ln_dm2dc    = .false.
+   ln_rnf      = .false.
+   ln_ssr      = .false.
+   nn_fwb      = 0
+/
+!-----------------------------------------------------------------------
+!       namsbc_rnf   runoffs namelist surface boundary condition
+!-----------------------------------------------------------------------
+!nn_runoff   =0 no, 1 runoff, 2 runoff+river mouth ups adv
+!rn_hrnf     runoffs, depth over which enhanced vertical mixing is used
+!rn_avt_rnf  runoffs, value of the additional vertical mixing coef. [m2/s]
+!cn_dir      Root directory for location of ssr files
+!sn_rnf      informations about the runoff file to be read
+!sn_cnf      informations about the runoff mouth file to be read
 !  THE ORDER OF THE FILES MATTER:
-!  1 - precipitation total (rain+snow)  in kg/m2/s
-!  2,3 -  u10,v10 -> scalar wind at 10m in m/s -  ON 'T' GRID POINTS!!!
-!  4 - solar radiation (short wave)     in W/m2
-!  5 - thermal radiation (long wave)    in W/m2
-!  6 - specific humidity                in %
-!  7 - temperature at 10m               in degrees K
-!  8 - precipitation (snow only)        in kg/m2/s
-!
-!  ln_2m         boolean (default F), used to indicate that Tair & humidity
-!                are given at 2m. In this case, the default file names &
-!                variables are t2.nc, t2, q2.nc, q2
-!  alpha_precip  real coefficient used as a multiplying  factor  for the precip
-!  clname        file names (256 char max for each)
-!  clvarname     name of variable in netcdf file (32 char max)
-!  freqh         frequency of fields in the file
-!                it is in hours (6 hourly, daily) if positive.
-!                if freqh = -12 the file contains 12 monthly data.
-&namcore
+!               !   file name        ! frequency (hours) ! variable   ! time interpolation !
+!               !                    !   (if <0  months) !   name     !     (logical)      !
+&namsbc_rnf
+   nn_runoff  = 2
+   rn_hrnf    = 0.e0
+   rn_avt_rnf = 1.e-3
+   cn_dir     = './'
+   sn_rnf     = 'runoff_1m_nomask.nc' ,      -12.        ,  'sorunoff',    .TRUE.   ,  1  ,  0     
+   sn_cnf     = 'runoff_1m_nomask.nc' ,        0.        ,  'socoefr' ,    .FALSE.  ,  1  ,  0              
+/
+!-----------------------------------------------------------------------
+!       namsbc_ana   analytical surface boundary condition
+!-----------------------------------------------------------------------
+!  nn_tau000   gently increase the stress over the first ntau_rst time-steps
+!  rn_utau0    uniform value used as default surface heat flux
+!  rn_vtau0    uniform value used as default solar radiation flux
+!  rn_q0       uniform value used as default surface heat flux
+!  rn_qsr0     uniform value used as default solar radiation flux
+!  rn_emp0     uniform value used as default surface freswater budget (E-P)
+&namsbc_ana
+   nn_tau000  =   0
+   rn_utau0   =   0.5
+   rn_vtau0   =   0.e0
+   rn_q0      =   0.e0
+   rn_qsr0    =   0.e0
+   rn_emp0    =   0.e0
+/
+!-----------------------------------------------------------------------
+!       namsbc_flx   surface boundary condition : flux formulation (#ifdef "key_sbc_flux")
+!-----------------------------------------------------------------------
+!  cn_dir   directory in which the model is executed
+!
+!  THE ORDER OF THE FILES MATTER:
+!               !      file name     ! frequency (hours) ! variable ! time intepolation !  clim  ! starting !
+!               !                    !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
+&namsbc_flx
+   cn_dir       = './'
+   sn_utau      =      'utau.nc'     ,        24.        ,  'utau'  ,     .FALSE.       ,    0   ,     0
+   sn_vtau      =      'vtau.nc'     ,        24.        ,  'vtau'  ,     .FALSE.       ,    0   ,     0
+   sn_qtot      =      'qtot.nc'     ,        24.        ,  'qtot'  ,     .FALSE.       ,    0   ,     0
+   sn_qsr       =      'qsr.nc'      ,        24.        ,  'qsr'   ,     .FALSE.       ,    0   ,     0
+   sn_emp       =      'emp.nc'      ,        24.        ,  'emp'   ,     .FALSE.       ,    0   ,     0
+
+/      
+!-----------------------------------------------------------------------
+!       namsbc_clio  CLIO bulk formulea
+!-----------------------------------------------------------------------
+!  cn_dir   directory in which the model is executed
+!
+!  THE ORDER OF THE FILES MATTER:
+!               !   file name        ! frequency (hours) ! variable   ! time intepolation !  clim  ! starting !
+!               !                    !   (if <0  months) !   name     !    (logical)      !  (0/1) !  record  !
+&namsbc_clio
+   cn_dir       = './'
+   sn_utau      =    'taux_1m'    ,      -12.         ,  'sozotaux',    .FALSE.        ,    1   ,    0    
+   sn_vtau      =    'tauy_1m'    ,      -12.         ,  'sometauy',    .FALSE.        ,    1   ,    0    
+   sn_wndm      =    'flx'        ,      -12.         ,  'socliowi',    .FALSE.        ,    1   ,    0      
+   sn_tair      =    'flx'        ,      -12.         ,  'socliot1',    .FALSE.        ,    1   ,    0     
+   sn_humi      =    'flx'        ,      -12.         ,  'socliohu',    .FALSE.        ,    1   ,    0    
+   sn_ccov      =    'flx'        ,      -12.         ,  'socliocl',    .FALSE.        ,    1   ,    0      
+   sn_prec      =    'flx'        ,      -12.         ,  'socliopl',    .FALSE.        ,    1   ,    0       
+/
+!-----------------------------------------------------------------------
+!       namsbc_core  CORE bulk formulea
+!-----------------------------------------------------------------------
+!  cn_dir         directory in which the model is executed
+!  ln_2m          logical flag to use air temp. and hum referenced at 2m instead 10m
+!  alpha_precip   multiplication factor for precipitation (total & snow)
+!
+!  THE ORDER OF THE FILES MATTER:
+!               !   file name        ! frequency (hours) ! variable   ! time intepolation !  clim  ! starting !
+!               !                    !   (if <0  months) !   name     !    (logical)      !  (0/1) !  record  !
+&namsbc_core
+   cn_dir       = './'
    ln_2m        = .FALSE.
    alpha_precip = 1.
-   clname    = 'precip.nc' 'u10.nc' 'q10.nc' 'v10.nc' 'radsw.nc' 'radlw.nc' 't10.nc' 'snow.nc'
-   clvarname =  'precip'    'u10'    'q10'    'v10'    'radsw'    'radlw'    't10'    'snow'
-   freqh     =    -12        24        24       24       24         24        24       -12
-/
+   sn_wndi      =    'u10'        ,       24.         ,  'U_10_MOD',    .FALSE.        ,    1   ,    0    
+   sn_wndj      =    'v10'        ,       24.         ,  'V_10_MOD',    .FALSE.        ,    1   ,    0    
+   sn_qsr       =    'rad'        ,       24.         ,  'SWDN_MOD',    .FALSE.        ,    1   ,    0      
+   sn_qlw       =    'rad'        ,       24.         ,  'LWDN_MOD',    .FALSE.        ,    1   ,    0      
+   sn_tair      =    't10'        ,       24.         ,  'T_10_MOD',    .FALSE.        ,    1   ,    0     
+   sn_humi      =    'q10'        ,       24.         ,  'Q_10_MOD',    .FALSE.        ,    1   ,    0    
+   sn_prec      =    'precip'     ,      -12.         ,  'RAIN'    ,    .FALSE.        ,    1   ,    0      
+   sn_snow      =    'precip'     ,      -12.         ,  'SNOW'    ,    .FALSE.        ,    1   ,    0       
+/
+!-----------------------------------------------------------------------
+!       namsbc_cpl    coupled ocean/atmosphere model  (#ifdef "key_coupled")
+!-----------------------------------------------------------------------
+&namsbc_cpl
+/
+!-----------------------------------------------------------------------
+!       namsbc_ssr   surface boundary condition : sea surface restoring
+!-----------------------------------------------------------------------
+!  nn_sstr   =0/1   add a retroaction term in the surface heat flux
+!  nn_sssr   =O/1/2 add a damping term in the surface freshwater flux
+!             (=1, salt flux, concentration/dillution emps only)
+!             (=2, volume flux, both emp and emps are updated) 
+!  dqdt       magnitude of the retroaction on temperature [W/m2/K]
+!  deds       magnitude of the damping on salinity [mm/day]
+!  THE ORDER OF THE FILES MATTER:
+!               !   file name     ! frequency (hours) ! variable ! time intepolation !  clim  ! starting !
+!               !                 !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
+&namsbc_ssr
+   nn_sstr      = 0
+   nn_sssr      = 0
+   dqdt         = -40.
+   deds         =  27.7
+   sn_sst       =  'sst_data.nc'  ,         24.       ,  'sst'   ,     .FALSE.       ,    0   ,     0
+   sn_sss       =  'sss_data.nc'  ,        -12.       ,  'sss'   ,     .TRUE.        ,    0   ,     0
+/      
 !-----------------------------------------------------------------------
 !       namagrif    agrif parameters (#ifdef key_agrif)