Index: /trunk/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /trunk/CONFIG/GYRE/EXP00/namelist	(revision 907)
+++ /trunk/CONFIG/GYRE/EXP00/namelist	(revision 908)
@@ -1,14 +1,14 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  :       1 - run manager      (namrun, nam_ctl, nam_mpp, nam_mpp_dyndist, nam_ctl)
-!! namelists         2 - Domain           (nam_zgr, nam_zgr_sco, namdom)
-!!                   3 - Surface boundary (namsbc, namsbc_ana, namsbc_flx, namsbc_clio, namsbc_core
-!!                                         namsbc_cpl, namqsr, namsbc_rnf, namsbc_ssr, namalb)
-!!                   4 - lateral boundary (namlbc, namcla, namobc)
-!!                   5 - bottom  boundary (nambfr, nambbc, nambbl)
-!!                   6 - Tracer           (nameos, nam_traadv, nam_traldf, namtdp)
-!!                   7 - dynamics         (nam_dynadv, nam_dynvor, nam_dynhpg, namflg, nam_dynspg, nam_dynldf)
-!!                   8 - Verical physics  (namzdf, namnpc, namric, namtke, namkpp, namddm)
-!!                   9 - diagnostics      (namtrd, namgap, namspr, namflo, namptr)
-!!                   9 - miscellaneous    (namsol)
+!! NEMO/OPA  :  1 - run manager      (namrun, nam_ctl, nam_mpp, nam_mpp_dyndist, nam_ctl)
+!! namelists    2 - Domain           (nam_zgr, nam_zgr_sco, namdom)
+!!              3 - Surface boundary (namsbc, namsbc_ana, namsbc_flx, namsbc_clio, namsbc_core
+!!                                    namsbc_cpl, namqsr, namsbc_rnf, namsbc_ssr, namalb)
+!!              4 - lateral boundary (namlbc, namcla, namobc)
+!!              5 - bottom  boundary (nambfr, nambbc, nambbl)
+!!              6 - Tracer           (nameos, nam_traadv, nam_traldf, namtdp)
+!!              7 - dynamics         (nam_dynadv, nam_dynvor, nam_dynhpg, namflg, nam_dynspg, nam_dynldf)
+!!              8 - Verical physics  (namzdf, namnpc, namric, namtke, namkpp, namddm)
+!!              9 - diagnostics      (namtrd, namgap, namspr, namflo, namptr)
+!!              9 - miscellaneous    (namsol)
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !  CAUTION: some scripts does not support CAPITALs for logical definition 
@@ -313,8 +313,8 @@
 !       namsbc_rnf   runoffs namelist surface boundary condition
 !-----------------------------------------------------------------------
+!cn_dir      Root directory for location of ssr files
 !nn_runoff   =0 no, 1 runoff, 2 runoff+river mouth ups adv
 !rn_hrnf     runoffs, depth over which enhanced vertical mixing is used
 !rn_avt_rnf  runoffs, value of the additional vertical mixing coef. [m2/s]
-!cn_dir      Root directory for location of ssr files
 !sn_rnf      informations about the runoff file to be read
 !sn_cnf      informations about the runoff mouth file to be read
@@ -323,8 +323,8 @@
 !               !                    !   (if <0  months) !   name     !     (logical)      !
 &namsbc_rnf
+   cn_dir     = './'
    nn_runoff  = 0
    rn_hrnf    = 0.e0
    rn_avt_rnf = 1.e-3
-   cn_dir     = './'
    sn_rnf     = 'runoff_1m_nomask.nc' ,      -12.        ,  'sorunoff',    .true.   ,  1  ,  0     
    sn_cnf     = 'runoff_1m_nomask.nc' ,        0.        ,  'socoefr' ,    .false.  ,  1  ,  0              
@@ -333,4 +333,5 @@
 !       namsbc_ssr   surface boundary condition : sea surface restoring
 !-----------------------------------------------------------------------
+!  cn_dir    directory in which the model is executed
 !  nn_sstr   =0/1   add a retroaction term in the surface heat flux
 !  nn_sssr   =O/1/2 add a damping term in the surface freshwater flux
@@ -343,4 +344,5 @@
 !               !                 !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
 &namsbc_ssr
+   cn_dir       = './'
    nn_sstr      = 0
    nn_sssr      = 0
Index: /trunk/CONFIG/GYRE_LOBSTER/EXP00/namelist
===================================================================
--- /trunk/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 907)
+++ /trunk/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 908)
@@ -1,14 +1,14 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/OPA  :       1 - run manager      (namrun, nam_ctl, nam_mpp, nam_mpp_dyndist, nam_ctl)
-!! namelists         2 - Domain           (nam_zgr, nam_zgr_sco, namdom)
-!!                   3 - Surface boundary (namsbc, namsbc_ana, namsbc_flx, namsbc_clio, namsbc_core
-!!                                         namsbc_cpl, namqsr, namsbc_rnf, namsbc_ssr, namalb)
-!!                   4 - lateral boundary (namlbc, namcla, namobc)
-!!                   5 - bottom  boundary (nambfr, nambbc, nambbl)
-!!                   6 - Tracer           (nameos, nam_traadv, nam_traldf, namtdp)
-!!                   7 - dynamics         (nam_dynadv, nam_dynvor, nam_dynhpg, namflg, nam_dynspg, nam_dynldf)
-!!                   8 - Verical physics  (namzdf, namnpc, namric, namtke, namkpp, namddm)
-!!                   9 - diagnostics      (namtrd, namgap, namspr, namflo, namptr)
-!!                   9 - miscellaneous    (namsol)
+!! NEMO/OPA  :  1 - run manager      (namrun, nam_ctl, nam_mpp, nam_mpp_dyndist, nam_ctl)
+!! namelists    2 - Domain           (nam_zgr, nam_zgr_sco, namdom)
+!!              3 - Surface boundary (namsbc, namsbc_ana, namsbc_flx, namsbc_clio, namsbc_core
+!!                                    namsbc_cpl, namqsr, namsbc_rnf, namsbc_ssr, namalb)
+!!              4 - lateral boundary (namlbc, namcla, namobc)
+!!              5 - bottom  boundary (nambfr, nambbc, nambbl)
+!!              6 - Tracer           (nameos, nam_traadv, nam_traldf, namtdp)
+!!              7 - dynamics         (nam_dynadv, nam_dynvor, nam_dynhpg, namflg, nam_dynspg, nam_dynldf)
+!!              8 - Verical physics  (namzdf, namnpc, namric, namtke, namkpp, namddm)
+!!              9 - diagnostics      (namtrd, namgap, namspr, namflo, namptr)
+!!              9 - miscellaneous    (namsol)
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !  CAUTION: some scripts does not support CAPITALs for logical definition 
@@ -313,8 +313,8 @@
 !       namsbc_rnf   runoffs namelist surface boundary condition
 !-----------------------------------------------------------------------
+!cn_dir      Root directory for location of ssr files
 !nn_runoff   =0 no, 1 runoff, 2 runoff+river mouth ups adv
 !rn_hrnf     runoffs, depth over which enhanced vertical mixing is used
 !rn_avt_rnf  runoffs, value of the additional vertical mixing coef. [m2/s]
-!cn_dir      Root directory for location of ssr files
 !sn_rnf      informations about the runoff file to be read
 !sn_cnf      informations about the runoff mouth file to be read
@@ -323,8 +323,8 @@
 !               !                    !   (if <0  months) !   name     !     (logical)      !
 &namsbc_rnf
+   cn_dir     = './'
    nn_runoff  = 0
    rn_hrnf    = 0.e0
    rn_avt_rnf = 1.e-3
-   cn_dir     = './'
    sn_rnf     = 'runoff_1m_nomask.nc' ,      -12.        ,  'sorunoff',    .true.   ,  1  ,  0     
    sn_cnf     = 'runoff_1m_nomask.nc' ,        0.        ,  'socoefr' ,    .false.  ,  1  ,  0              
@@ -333,4 +333,5 @@
 !       namsbc_ssr   surface boundary condition : sea surface restoring
 !-----------------------------------------------------------------------
+!  cn_dir    directory in which the model is executed
 !  nn_sstr   =0/1   add a retroaction term in the surface heat flux
 !  nn_sssr   =O/1/2 add a damping term in the surface freshwater flux
@@ -343,4 +344,5 @@
 !               !                 !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
 &namsbc_ssr
+   cn_dir       = './'
    nn_sstr      = 0
    nn_sssr      = 0
Index: /trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 907)
+++ /trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 908)
@@ -313,8 +313,8 @@
 !       namsbc_rnf   runoffs namelist surface boundary condition
 !-----------------------------------------------------------------------
+!cn_dir      Root directory for location of ssr files
 !nn_runoff   =0 no, 1 runoff, 2 runoff+river mouth ups adv
 !rn_hrnf     runoffs, depth over which enhanced vertical mixing is used
 !rn_avt_rnf  runoffs, value of the additional vertical mixing coef. [m2/s]
-!cn_dir      Root directory for location of ssr files
 !sn_rnf      informations about the runoff file to be read
 !sn_cnf      informations about the runoff mouth file to be read
@@ -323,8 +323,8 @@
 !               !                    !   (if <0  months) !   name     !     (logical)      !
 &namsbc_rnf
+   cn_dir     = './'
    nn_runoff  = 2
    rn_hrnf    = 0.e0
    rn_avt_rnf = 1.e-3
-   cn_dir     = './'
    sn_rnf     = 'runoff_1m_nomask.nc' ,      -12.        ,  'sorunoff',    .true.   ,  1  ,  0     
    sn_cnf     = 'runoff_1m_nomask.nc' ,        0.        ,  'socoefr' ,    .false.  ,  1  ,  0              
@@ -333,4 +333,5 @@
 !       namsbc_ssr   surface boundary condition : sea surface restoring
 !-----------------------------------------------------------------------
+!  cn_dir    directory in which the model is executed
 !  nn_sstr   =0/1   add a retroaction term in the surface heat flux
 !  nn_sssr   =O/1/2 add a damping term in the surface freshwater flux
@@ -343,4 +344,5 @@
 !               !                 !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
 &namsbc_ssr
+   cn_dir       = './'
    nn_sstr      = 0
    nn_sssr      = 0
Index: /trunk/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 907)
+++ /trunk/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 908)
@@ -313,8 +313,8 @@
 !       namsbc_rnf   runoffs namelist surface boundary condition
 !-----------------------------------------------------------------------
+!cn_dir      Root directory for location of ssr files
 !nn_runoff   =0 no, 1 runoff, 2 runoff+river mouth ups adv
 !rn_hrnf     runoffs, depth over which enhanced vertical mixing is used
 !rn_avt_rnf  runoffs, value of the additional vertical mixing coef. [m2/s]
-!cn_dir      Root directory for location of ssr files
 !sn_rnf      informations about the runoff file to be read
 !sn_cnf      informations about the runoff mouth file to be read
@@ -323,8 +323,8 @@
 !               !                    !   (if <0  months) !   name     !     (logical)      !
 &namsbc_rnf
+   cn_dir     = './'
    nn_runoff  = 2
    rn_hrnf    = 0.e0
    rn_avt_rnf = 1.e-3
-   cn_dir     = './'
    sn_rnf     = 'runoff_1m_nomask.nc' ,      -12.        ,  'sorunoff',    .true.   ,  1  ,  0     
    sn_cnf     = 'runoff_1m_nomask.nc' ,        0.        ,  'socoefr' ,    .false.  ,  1  ,  0              
@@ -333,4 +333,5 @@
 !       namsbc_ssr   surface boundary condition : sea surface restoring
 !-----------------------------------------------------------------------
+!  cn_dir    directory in which the model is executed
 !  nn_sstr   =0/1   add a retroaction term in the surface heat flux
 !  nn_sssr   =O/1/2 add a damping term in the surface freshwater flux
@@ -343,4 +344,5 @@
 !               !                 !   (if <0  months) !   name   !    (logical)      !  (0/1) !  record  !
 &namsbc_ssr
+   cn_dir       = './'
    nn_sstr      = 0
    nn_sssr      = 0