Index: trunk/NEMO/LIM_SRC_3/limthd_sal.F90
===================================================================
--- trunk/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 888)
+++ trunk/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 921)
@@ -38,5 +38,5 @@
       zone   = 1.e0
 
-   CONTAINS
+CONTAINS
 
    SUBROUTINE lim_thd_sal(kideb,kiut)
@@ -95,5 +95,5 @@
          zccc           ,    &   !: dummy factor
          zdiscrim                !: dummy factor
- 
+
       REAL(wp), DIMENSION(jpij) ::          &
          ze_init        ,    &   !initial total enthalpy
@@ -103,14 +103,14 @@
       !!---------------------------------------------------------------------
 
-!------------------------------------------------------------------------------|
-! 1) Constant salinity, constant in time                                       |
-!------------------------------------------------------------------------------|
+      !------------------------------------------------------------------------------|
+      ! 1) Constant salinity, constant in time                                       |
+      !------------------------------------------------------------------------------|
 
       IF (num_sal.eq.1) THEN
 
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
-         num_sal
-         WRITE(numout,*) '~~~~~~~~~~~~'
+         !         WRITE(numout,*)
+         !         WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
+         !         num_sal
+         !         WRITE(numout,*) '~~~~~~~~~~~~'
 
          DO jk = 1, nlay_i
@@ -126,15 +126,15 @@
       ENDIF ! num_sal .EQ. 1
 
-!------------------------------------------------------------------------------|
-!  Module 2 : Constant salinity varying in time                                |
-!------------------------------------------------------------------------------|
+      !------------------------------------------------------------------------------|
+      !  Module 2 : Constant salinity varying in time                                |
+      !------------------------------------------------------------------------------|
 
       IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN
 
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
-         num_sal
-         WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*)
+         !         WRITE(numout,*)
+         !         WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
+         !         num_sal
+         !         WRITE(numout,*) '~~~~~~~~~~~'
+         !         WRITE(numout,*)
 
          !---------------------------------
@@ -143,5 +143,5 @@
          DO ji = kideb, kiut
             zhiold(ji)   =  ht_i_b(ji) - dh_i_bott(ji) - dh_snowice(ji) -     &
-                            dh_i_surf(ji)
+               dh_i_surf(ji)
          END DO ! ji
 
@@ -172,5 +172,5 @@
             i_ice_switch = 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_i_b(ji) + 1.0e-2 ) )
             isnowic      = 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - dh_snowice(ji) ) ) * &
-                           i_ice_switch
+               i_ice_switch
 
             !---------------------
@@ -180,11 +180,11 @@
             ! drainage by gravity drainage
             dsm_i_gd_1d(ji) = - igravdr *                                     & 
-                                MAX( sm_i_b(ji) - sal_G , 0.0 ) /             &
-                                time_G * rdt_ice 
+               MAX( sm_i_b(ji) - sal_G , 0.0 ) /             &
+               time_G * rdt_ice 
 
             ! drainage by flushing  
             dsm_i_fl_1d(ji)  = - iflush *                                     &
-                                MAX( sm_i_b(ji) - sal_F , 0.0 ) /             & 
-                                time_F * rdt_ice
+               MAX( sm_i_b(ji) - sal_F , 0.0 ) /             & 
+               time_F * rdt_ice
 
             !-----------------
@@ -197,10 +197,10 @@
             zsiold(ji) = sm_i_b(ji)
             sm_i_b(ji) = sm_i_b(ji)                                           &
-                       + dsm_i_fl_1d(ji) + dsm_i_gd_1d(ji)  !                 &
+               + dsm_i_fl_1d(ji) + dsm_i_gd_1d(ji)  !                 &
 
             ! if no ice, salinity eq 0.1
             i_ice_switch  = 1.0 - MAX ( 0.0, SIGN (1.0 , - ht_i_b(ji) ) )
             sm_i_b(ji)    = i_ice_switch*sm_i_b(ji) + s_i_min * ( 1.0 -       &
-                            i_ice_switch )
+               i_ice_switch )
          END DO ! ji
 
@@ -229,7 +229,7 @@
             i_ice_switch  = 1.0 - MAX ( 0.0, SIGN (1.0 , - ht_i_b(ji) ) )
             fsbri_1d(ji) = fsbri_1d(ji) -  &
-                           i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji) *  &
-                           ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), &
-                             sm_i_b(ji) - zsiold(ji) ) ) / rdt_ice
+               i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji) *  &
+               ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), &
+               sm_i_b(ji) - zsiold(ji) ) ) / rdt_ice
             IF ( num_sal .EQ. 4 ) fsbri_1d(ji) = 0.0
 
@@ -248,9 +248,9 @@
                zaaa         =  cpic
                zbbb         =  ( rcp - cpic ) * ( ztmelts - rtt ) + &
-                               q_i_b(ji,jk) / rhoic - lfus
+                  q_i_b(ji,jk) / rhoic - lfus
                zccc         =  lfus * ( ztmelts - rtt )
                zdiscrim     =  SQRT( MAX(zbbb*zbbb - 4.0*zaaa*zccc,0.0) )
                t_i_b(ji,jk) =  rtt - ( zbbb + zdiscrim ) / & 
-                                     ( 2.0 *zaaa )
+                  ( 2.0 *zaaa )
             END DO !ji
 
@@ -259,7 +259,7 @@
       ENDIF ! num_sal .EQ. 2
 
-!------------------------------------------------------------------------------|
-!  Module 3 : Profile of salinity, constant in time                            |
-!------------------------------------------------------------------------------|
+      !------------------------------------------------------------------------------|
+      !  Module 3 : Profile of salinity, constant in time                            |
+      !------------------------------------------------------------------------------|
 
       IF ( num_sal .EQ. 3 ) THEN
@@ -267,5 +267,5 @@
          WRITE(numout,*)
          WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
-         num_sal
+            num_sal
          WRITE(numout,*) '~~~~~~~~~~~~'
 
@@ -274,7 +274,7 @@
       ENDIF ! num_sal .EQ. 3
 
-!------------------------------------------------------------------------------|
-!  Module 4 : Constant salinity varying in time                                |
-!------------------------------------------------------------------------------|
+      !------------------------------------------------------------------------------|
+      !  Module 4 : Constant salinity varying in time                                |
+      !------------------------------------------------------------------------------|
 
       ! Cox and Weeks, 1974
@@ -283,5 +283,5 @@
          WRITE(numout,*)
          WRITE(numout,*) 'lim_thd_sal : Ice salinity computation module ', &
-         num_sal
+            num_sal
          WRITE(numout,*) '~~~~~~~~~~~~'
 
@@ -296,5 +296,5 @@
                sm_i_b(ji)    = MIN(sm_i_b(ji),zsold)  
             ENDIF
-         
+
             IF ( ht_i_b(ji) .GT. 3.06918239 ) THEN 
                sm_i_b(ji)     = 3.0
@@ -304,12 +304,12 @@
                s_i_b(ji,jk)   = sm_i_b(ji)
             END DO
-      
+
          END DO ! ji
 
       ENDIF ! num_sal
 
-!------------------------------------------------------------------------------|
-! 5) Computation of salt flux due to Bottom growth
-!------------------------------------------------------------------------------|
+      !------------------------------------------------------------------------------|
+      ! 5) Computation of salt flux due to Bottom growth
+      !------------------------------------------------------------------------------|
 
       IF ( num_sal .EQ. 4 ) THEN
@@ -318,7 +318,7 @@
             zjj                 = ( npb(ji) - 1 ) / jpi + 1
             fseqv_1d(ji) = fseqv_1d(ji)              + & 
-                           ( sss_m(zji,zjj) - bulk_sal    ) * & 
-                           rhoic * a_i_b(ji) * &
-                           MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
+               ( sss_m(zji,zjj) - bulk_sal    ) * & 
+               rhoic * a_i_b(ji) * &
+               MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
          END DO
       ELSE
@@ -327,13 +327,13 @@
             zjj                 = ( npb(ji) - 1 ) / jpi + 1
             fseqv_1d(ji) = fseqv_1d(ji)              + & 
-                           ( sss_m(zji,zjj) - s_i_new(ji) ) * & 
-                             rhoic * a_i_b(ji) * &
-                             MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
+               ( sss_m(zji,zjj) - s_i_new(ji) ) * & 
+               rhoic * a_i_b(ji) * &
+               MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
          END DO ! ji
       ENDIF
 
-!-- End of salinity computations
+      !-- End of salinity computations
    END SUBROUTINE lim_thd_sal
-!==============================================================================
+   !==============================================================================
 
    SUBROUTINE lim_thd_sal_init
@@ -352,5 +352,5 @@
       !!-------------------------------------------------------------------
       NAMELIST/namicesal/ num_sal, bulk_sal, sal_G, time_G, sal_F, time_F, &
-                          s_i_max, s_i_min, s_i_0, s_i_1
+         s_i_max, s_i_min, s_i_0, s_i_1
       !!-------------------------------------------------------------------
 